//
//  GSInterpolationFontProxy.h
//  GlyphsCore
//
//  Created by Georg Seifert on 02.06.15.
//  Copyright (c) 2015 schriftgestaltung.de. All rights reserved.
//

#import <Foundation/Foundation.h>

@class GSFont;
@class GSGlyph;
@class GSInstance;
@class GSFontMaster;

@interface GSInterpolationFontProxy : NSObject {
	NSMutableDictionary *_glyphCache;
	GSInstance * _instance;
	NSDictionary * _instanceInterpolation;
	GSFont *__weak _font;
	GSFontMaster *_fontMaster;
	NSMutableDictionary *_localInterpolationsMapping;
}
- (instancetype)initWithFont:(GSFont *)Font instance:(GSInstance *)Instance;
- (NSString *)fontMasterID;
- (GSGlyph *)glyphForName:(NSString *)name;
- (GSGlyph *)glyphForCharacter:(UTF32Char)Char;
- (GSGlyph *)glyphForName:(NSString *)Name smartSettings:(NSDictionary*)smartSettings;
- (void)resetCache;
@end
