//
//  table__g_v_a_r.h
//  GSFontTools
//
//  Created by Georg Seifert on 31.08.16.
//  Copyright 2016 schriftgestaltung.de. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "TTable.h"

@class FTPointArray;
@class GSIntArray;

NSArray *range(NSUInteger count);

@interface table__g_v_a_r : TTable {}

@property (nonatomic) uint16_t version; //	H
@property (nonatomic) uint16_t reserved; //	H
@property (nonatomic) uint16_t axisCount; //	H
@property (nonatomic) uint16_t sharedCoordCount; //H
@property (nonatomic) uint16_t glyphCount; //	H
@property (nonatomic) uint16_t flags; //		H
@property (nonatomic, strong) NSMutableDictionary* variations;

+ (NSArray *)decompileOffsets:(NSData*)data tableFormat:(unsigned short)tableFormat glyphCount:(NSUInteger)glyphCount;
- (NSArray *)decompileGlyph:(NSData *)data numPointsInGlyph:(NSUInteger)numPointsInGlyph sharedCoords:(NSArray*)sharedCoords axisTags:(NSArray*)axisTags;
- (NSArray*)decompileSharedCoords:(NSArray *)axisTags data:(NSData*)data pos:(NSUInteger*)pos;
+ (NSArray *)computeMinMaxCoord:(NSDictionary*)coord;

- (NSData*)compileGlyph:(NSString*)glyphName numPointsInGlyph:(NSUInteger)numPointsInGlyph axisTags:(NSArray*)axisTags sharedCoordIndices:(NSDictionary*)sharedCoordIndices error:(NSError**)error;
- (NSArray*)compileSharedCoords:(NSArray*)axisTags;
+ (NSData*)compileOffsets:(NSArray*)offsets tableFormat:(short*)tableFormat;
@end

@interface GXGlyphVariation : NSObject {}

@property (nonatomic, strong) NSMutableDictionary *axes;
@property (nonatomic, strong) NSArray *coordinates;

- (instancetype)initWithAxis:(NSDictionary*)axis coordinates:(NSArray*)coordinates;
	//def __init__(self, axes, coordinates):
- (void) toXML:(GSXMLWriter*)Writer axisTags:(NSArray*)axisTags;

+ (NSArray *)decompilePoints:(NSData*)data numPointsInGlyph:(NSUInteger)numPointsInGlyph pos:(NSUInteger*)pos;
+ (NSDictionary*)decompileCoord:(NSData*)data axisTags:(NSArray*)axisTags pos:(NSUInteger*)pos;
+ (NSArray*)decompileCoords:(NSData*)data axisTags:(NSArray*)axisTags numCoords:(NSUInteger)numCoords pos:(NSUInteger*)pos;
+ (NSArray*)decompileDeltas:(NSData*)data numDeltas:(NSUInteger)numDeltas pos:(NSUInteger*)pos;
- (BOOL)hasImpact;
+ (NSUInteger)tupleSizeForFlags:(NSUInteger)flags axisCount:(NSUInteger)axisCount;

- (BOOL)compile:(NSMutableData*)tupleData auxData:(NSMutableData*)auxData axisTags:(NSArray*)axisTags sharedCoordIndices:(NSDictionary*)sharedCoordIndices sharedPoints:(NSArray*)sharedPoints error:(NSError**)error;
- (NSData*)compileCoord:(NSArray*)axisTags;
- (NSData*)compileIntermediateCoord:(NSArray*)axisTags;
+ (NSData*)compilePoints:(NSArray*)points numPointsInGlyph:(NSUInteger)numPointsInGlyph;
@end
